import type { Runtype } from './runtype';
/**
 * An object that matches a Typecript `Record<KeyType, ValueType>` type.
 *
 * You pass a runtype for the objects keys and one for its values.
 * Keeps you save from unwanted propertiers and evil __proto__ injections.
 */
export declare function dictionary<T extends Runtype<any>, U extends Runtype<any>>(keyRuntype: T, valueRuntype: U): Runtype<Record<ReturnType<T>, ReturnType<U>>>;
